package com.wim.deploy;

import java.io.*;
import java.util.*;

import com.ibm.broker.config.proxy.*;

public class DeployBAR {

	public static void main(String[] args) {
		if (args.length != 3) {
			System.err.println("USAGE : com.wim.deployBAR propsFile BARfile execGroupName");
			System.err.println("		propsLoc - path to properties file.");
			System.err.println("		BARFilePath - path to BAR file to be deployed.");
			System.err.println("		exceGroupName - name of execution group name to deploy.");
			System.exit(1);
		}
		
		int compCode = -1;
		DeployBrokerArchive dba = new DeployBrokerArchive();
		try {
			dba.setBrokerProps(args[0]);
			dba.setDeployParms(args[1], args[2]);
			
			List<String> l = dba.connProps();
			for(int i=0; i<l.size(); i++) {
				System.out.println(l.get(i));
			}
			l.clear();
			
			dba.setProxyObjects();
			
			l = dba.brokerProps();
			for(int i=0; i<l.size(); i++) {
				System.out.println(l.get(i));
			}
			l.clear();
			
			l = dba.execGroupProps();
			for(int i=0; i<l.size(); i++) {
				System.out.println(l.get(i));
			}
			l.clear();
			
			l = dba.barFileProps();
			for(int i=0; i<l.size(); i++) {
				System.out.println(l.get(i));
			}
			l.clear();
			
			compCode = dba.doDeploy();
			
		} catch (FileNotFoundException fnfe) {
			traceException(fnfe);
		} catch (IOException ioe) {
			traceException(ioe);
		} catch (ConfigManagerProxyPropertyNotInitializedException cmppne) {
			traceException(cmppne);
		} catch (ConfigManagerProxyLoggedException cmple) {
			traceException(cmple);
		} catch (Exception e) {
			traceException(e);
		} finally {
			System.out.println("Deployment completed " + compCode);
		}
	}
	
	public static void traceException(Exception e) {
		System.err.println("Exception Message : " + e.getMessage());
		e.printStackTrace();
	}

}
